<template>
    <v-container>
        <v-row>
            <v-col>
                <h1>Signup</h1>
                <v-form ref="signUpForm" v-model="formValidity">
                    <v-text-field :rules="emailRules" label="Email" required v-model="email"></v-text-field>
                    <v-autocomplete :items="browsers" label="Which browser do you use?"></v-autocomplete>
                    <v-file-input label="Attach profile picture"></v-file-input>

                    <v-dialog persistent="true" ref="dialog" v-model="modal" width="290px">
                        <template v-slot:activator="{on, attrs}">
                            <v-text-field label="Birthday" prepend-icon="mdi-calendar" readonly v-bind="attrs"
                                          v-model="birthday"
                                          v-on="on"></v-text-field>
                        </template>

                        <v-date-picker locale="pl" scrollable v-model="birthday">
                            <v-spacer></v-spacer>
                            <v-btn @click="modal = false" color="primary" text>Cancel</v-btn>
                            <v-btn @click="$refs.dialog.save(birthday)" color="primary" text>OK</v-btn>
                        </v-date-picker>
                    </v-dialog>
                    <v-checkbox :rules="agreeToTermsRules" label="Agree to terms and conditions" required
                                v-model="agreeToTerms"></v-checkbox>
                    <v-btn color="primary" type="submit" class="mr-4" :disabled="!formValidity">Submit</v-btn>
                    <v-btn class="mr-4" color="success" @click="validateForm">Validate Form</v-btn>
                    <v-btn @click="resetValidation" color="warning" class="mr-4">Reset Validation</v-btn>
                    <v-btn @click="resetForm" color="error">Reset</v-btn>

                </v-form>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    export default {
        name: "Signup",
        data: () => ({
            agreeToTerms: false,
            agreeToTermsRules: [
                value => !!value || "You must agree to the terms and conditions to sugn up for an account."
            ],
            email: '',
            emailRules: [
                value => !!value || 'Email is required.',
                value => value.indexOf('@') !== 0 || 'Email should have a username.',
                value => value.includes('@') || 'Email should include an @ symbol.',
                value => value.indexOf('.') - value.indexOf('@') > 1 || 'Email should contain a proper domain.',
                value => value.indexOf('.') <= value.length - 3 || 'Email should contain a valid domain extension.'
            ],
            birthday: new Date().toISOString().substr(0, 10),
            modal: false,
            browsers: [
                'Chrome', 'Firefox', 'Edge', 'Opera'
            ],
            formValidity: false
        }),
        methods: {
            resetForm() {
                this.$refs.signUpForm.reset()
            },
            resetValidation() {
                this.$refs.signUpForm.resetValidation()
            },
            validateForm() {
                this.$refs.signUpForm.validate()
            }
        }
    }
</script>

<style scoped>

</style>